/****************************************************************** 
* @author Alois Kirchsteiger member of the isac team
* Copyright (c) 2004 by Alois Kirchsteiger
* create 10.12.2004, 12:51:27
* Insitute for Softwaretechnology, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui;

import isac.bridge.BridgeRMI;
import isac.util.CalcChangedEvent;
import isac.util.interfaces.IToUser;
import isac.util.interfaces.IToWorksheet;
import isac.wsdialog.IUserAction;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;

import org.apache.log4j.Logger;

/**
 * @author Alois Kirchsteiger 10.12.2004 12:51:27
 */
public class WorksheetRMI extends UnicastRemoteObject implements IToUser, IToWorksheet {

  Worksheet ws_;
	
	static Logger logger_ = Logger.getLogger(BridgeRMI.class.getName());

  /**
   * @throws RemoteException
   */
  protected WorksheetRMI(Worksheet ws) throws RemoteException {
    super();
    rmiBind();
    ws_ = ws;
  }

  /* (non-Javadoc)
   * @see isac.util.interfaces.IToUser#calcChanged(isac.util.CalcChangedEvent)
   */
  public void calcChanged(CalcChangedEvent event) throws RemoteException {
	logger_.fatal("WS<-. . : informListeners (unc="
			+ event.getLastUnchangedFormula().toSMLString() + ", del="
			+ event.getLastDeletedFormula().toSMLString() + ", gen="
			+ event.getLastGeneratedFormula().toSMLString());
	logger_.fatal("WS<-. . : getCalcChangedEvent("+")");
    ws_.calcChanged(event);
  }

  private void rmiBind() {
    if (System.getSecurityManager() == null) {
      System.setSecurityManager(new RMISecurityManager());
    }

    try {
      LocateRegistry.createRegistry(1066);
    } catch (java.rmi.RemoteException exc2) {
      System.err.println("can not create registry: " + exc2.getMessage());
    }

    String name = "//localhost/isac-WorksheetRMI";
    try {
      System.out.println("try to bind as " + name);
      Naming.rebind(name, this);
      System.out.println("WorksheetRMI bound to " + name);
      //WN040906      was Object Manager ...
    } catch (java.rmi.ConnectException e) {
      System.err.println("failed to contact as " + name
          + " (creating RMI-Server on localhost: 1099)");
    } catch (RemoteException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    } catch (MalformedURLException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }

  /* (non-Javadoc)
   * @see isac.util.interfaces.IToWorksheet#doUIAction(isac.wsdialog.IUserAction)
   */
  public boolean doUIAction(IUserAction action) throws RemoteException {
    return ws_.doUIAction(action);
  }
}
