/****************************************************************** 
* @author Alois Kirchsteiger member of the isac team
* Copyright (c) 2004 by Alois Kirchsteiger
* create 31.08.2004, 11:46:39
* Insitute for Softwaretechnology, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/


package isac.gui.browser;

import java.awt.Dimension;

import javax.swing.*;

/**
 * @author Alois Kirchsteiger 31.08.2004 11:46:39
 */
public class BrowserWindow extends JPanel {
    protected TabPanel tabPanel;
    protected JSplitPane splitPane;
    //TODO: temporary solution, will be changed to HTMLEditorKit
    protected JDesktopPane desktopPane;
    
    public BrowserWindow(TabPanel tabPanel) {
        this.tabPanel = tabPanel;
        buildSplitPane();
        this.setVisible(true);
    }
    
    public void setTabPanel(TabPanel tabPanel) {
        this.tabPanel = tabPanel;
    }
    
    public TabPanel getTabPanel() {
        return this.tabPanel;
    }
    
    private void buildSplitPane() {
        this.splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, false);
        tabPanel.setMinimumSize(new Dimension(250,600));
        tabPanel.setPreferredSize(new Dimension(250,600));
        splitPane.setLeftComponent(new JScrollPane(tabPanel));
        desktopPane = new JDesktopPane();
        desktopPane.setMinimumSize(new Dimension(50,600));
        splitPane.setRightComponent(desktopPane);
        splitPane.setOneTouchExpandable(true);
        splitPane.setDividerLocation(-1);
        this.add(splitPane);
    }

}
