/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Feb 4, 2005 5:50:41 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;

import java.util.Vector;

/**
 * renames Vector#add to FormHeadsContainer#setResponse
 * as required by @see isac.util.parser.XMLParserDigest
 * reason: setResponse is for both:
 *   FormHeadsContainer#setResponse in GETELEMENTSFROMTO
 * and
 *   ResponseWrapper#setResponse in REFCALCHEAD
 */
public class FormHeadsContainer {
	Vector form_heads_;

	public FormHeadsContainer() {
		form_heads_ = new Vector();
	}

	public void setResponse(CalcElement c) {
		form_heads_.add(c);
	}

	public Vector getElements() {
		return form_heads_;
	}
}

