/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 30, 2004, 3:35:30 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.formulae;

import java.util.Iterator;
import java.util.Vector;

/**
 * identifier for a method and key into the hierarchy of methods
 * 
 * @author Walther Neuper Sep 30, 2004, 3:35:30 PM
 * @version 1.0
 * @see <isac.util.formulae.ProblemID>
 **/
public class MethodID extends CalcHeadCompoundID {

	private Vector methodID = new Vector();

	public MethodID() {
	}

	public String toSMLString() {
		StringBuffer sb = new StringBuffer();
		if (methodID.size() > 0) {
			sb.append(" [");
			Iterator it = methodID.iterator();
			while (it.hasNext()) {
				sb.append("\"" + it.next() + "\",");
			}
			sb.deleteCharAt(sb.length() - 1); // remove last ","
			sb.append("]");
		} else {
			sb.append("[]");
		}
		return sb.toString();
	}
	
	
}
