/*
 * Created on Oct 2, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package isac.wsdialog;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import isac.bridge.CalcIterator;
import isac.util.formulae.Assumption;
import isac.util.formulae.CalcHead;
import isac.util.formulae.CalcFormula;
import isac.util.formulae.Position;
import isac.util.interfaces.ICalcElement;
import isac.util.interfaces.ICalcIterator;
import isac.util.tactics.Tactic;


/**
 * @author Alan Krempler
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DialogIterator extends UnicastRemoteObject implements ICalcIterator {

  /**
   * @param calcTree
   */
  protected CalcIterator calc_iterator_;
  
  public DialogIterator(CalcIterator calc_iterator) throws RemoteException{
	  calc_iterator_ = calc_iterator;  	
  }

  /**
   *  get the Position of the current element in the CalcTree
   */
  public Position getPosition() {//TODO.WN041208 getSmlPos ?
		return calc_iterator_.getPosition();
	}
 
  /**
  * Reference the first (root) element in the attached calculation tree. 
  * @return Like all the moveXXX methods this returns true on success, 
  * false if there is no element to move to. 
  */
  public boolean moveRoot() throws RemoteException{
  	return calc_iterator_.moveRoot();
  }
  
  /**
  * Reference the first (root) element in the attached calculation tree. 
  * @return Like all the moveXXX methods this returns true on success, 
  * false if there is no element to move to. 
  */
  public boolean moveCalcHead() throws RemoteException{
    return calc_iterator_.moveCalcHead();
  }
	
  /**
  * Reference the previous formula in the attached calculation tree.
  * @return Like all the moveXXX methods this returns true on success, 
  false if there is no element to move to. 
  */
  public boolean moveUp() throws RemoteException{
	return calc_iterator_.moveUp();
  }
	
  /**
  Reference the next formula in the attached calculation tree.
  * @return Like all the moveXXX methods this returns true on success, 
  false if there is no element to move to. 
  */
  public boolean moveDown() throws RemoteException{
	return calc_iterator_.moveDown(); 
  }

  /**
  Enter the next coarser level of refinement in the attached calculation tree.
  * @return Like all the moveXXX methods this returns true on success, 
  false if there is no element to move to. 
  */
  public boolean moveLevelUp() throws RemoteException{
	return calc_iterator_.moveLevelUp();
  }

  /**
  Enter the next more detailed level of refinement in the 
  attached calculation tree.
  * @return Like all the moveXXX methods this returns true on success, 
  false if there is no element to move to. 
  */
  public boolean moveLevelDown() throws RemoteException{
	return calc_iterator_.moveLevelDown();
  }

  /**
  Reference the tactic which resulted in the currently selected element of 
  the attached calculation tree. 
  <p>A special case arises if the tactic to continue the current calculation 
  is solving a subproblem. The subproblem is a calculation on its own, 
  represented by a separate calculation(sub-)tree object. A reference to the 
  calculationtree representing the subproblem is passed to the worksheet. 
  The worksheet will handle the situation accordingly, e.g. by opening a new 
  worksheet or displaying the new calculationtree (indented) in the current
  worksheet. 
  * @return Like all the moveXXX methods this returns true on success, 
  false if there is no element to move to. 
  */
  public boolean moveTactic() throws RemoteException{
	return calc_iterator_.moveTactic();
  }

  /**
  Reference the formula which resulted in the currently selected element 
  of the attached calculation tree.
  */
  public boolean moveFormula() throws RemoteException{
	return calc_iterator_.moveFormula();
  }

  /* (non-Javadoc)
   * @see isac.util.interfaces.ICalcIterator#isLast()
   */
  public boolean isLast() throws RemoteException{
  	// TODO implement
  	return true;
  }
  /*WN-40820 by AK parallel to MH
  	public boolean isLast() {
	return calc_iterator_.isLast();
  }*/


  /**
   * Use this to get the current element and check
   * the type by calling getType().
   * 
   * @return The currently referenced Element
   * @see getType()
   */
  public ICalcElement getElement() throws RemoteException{
	return calc_iterator_.getElement();
  }
	
  
  /**
  The current level of nesting into subcalculations.
  * @return An int representing level of nesting (higher == more detailed)
  <p>Special values:
  <p>0: outmost level: only first and last step of calculation are on this level 
  */ 
  public int getLevel() throws RemoteException{
	return calc_iterator_.getLevel();	
  }
  
  public Object clone(){
    try {
  	  return new DialogIterator((CalcIterator) calc_iterator_.clone());	
    } catch (Exception e){
      e.printStackTrace();
    }
    return null;
  }
  
  public int compareTo(Object c){
  	return calc_iterator_.compareTo(c);
  }
/* (non-Javadoc)
 * @see isac.util.interfaces.ICalcIterator#getFormula()
 */
public ICalcElement getFormula() throws RemoteException{
	// TODO Auto-generated method stub
	return null;
}
/* (non-Javadoc)
 * @see isac.util.interfaces.ICalcIterator#getTactic()
 */
public Tactic getTactic() throws RemoteException{
	// TODO Auto-generated method stub
	return null;
}
/* (non-Javadoc)
 * @see isac.util.interfaces.ICalcIterator#getAssumption()
 */
public Assumption getAssumption() throws RemoteException{
	// TODO Auto-generated method stub
	return null;
}

public String toSMLString() {
	return this.calc_iterator_.toSMLString();
//	WN041104 hack for testing
//	ICalcElement e = this.getFormula();
//	Position p;
//	if (e.getType() == ICalcElement.CALCEL_CALCHEAD)
//		p = ((CalcHead) e).getPosition();
//	else
//		p = ((Formula) e).getPosition();	
//	return p.toSMLString();
}

}
