/*
 * Created on Nov 18, 2003
 */
package isac.wsdialog;

/**
 * Exception thrown by the DialogGuide if the action requested by the user does
 * not match the state of the DialogGuide, e.g. specifying during the solving
 * phase.
 * 
 * @author Alan Krempler
 */
public class DialogProtocolException extends Exception {

  protected int failed_action_;

  protected int dialog_state_;

  DialogProtocolException(int failed_action, int dialog_state, String extra,
                          Throwable cause) {
    super("The DialogGuide cannot process a request.\n" + "Requested action: "
        + String.valueOf(failed_action) + ", Dialog state:"
        + String.valueOf(dialog_state) + ", " + extra);
    failed_action_ = failed_action;
    dialog_state_ = dialog_state;
  }

  DialogProtocolException(int failed_action, int dialog_state) {
    this(failed_action, dialog_state, null, null);
  }
}