(* use"kbtest/diffapp.sml";
   use"diffapp.sml";
   WW.N.1.3.00
   + see "test-circle.sml" for pre-, postconditions
   + see "test-coil-kernel.sml" for variants etc.
*)

"Contents----------------------------------------------";
"              Specify_Problem (match_itms_oris)       ";
"              test specify, fmz <> []                  ";
"              test specify, fmz = []                  ";
"          problemtypes + formalizations               ";
"-------------------- ptree of {(a,b). is-max ... ----------------";
"--------- me .. scripts for maximum-example ---------------------";
"--------- autoCalc .. scripts for maximum-example ---------------";






" #################################################### ";
"              Specify_Problem (match_itms_oris)       ";
" #################################################### ";
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ["DiffApp","max_by_calculus"]);
val c = []:cid;

(*val nxt = Init_Proof' (fmz,(dI',pI',mI'));
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt e_pos' [] EmptyPtree;
*)
val (p,_,f,(_,nxt),_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "fixedValues [(r::real) = Arbfix]" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

(*---6.5.03
val nxt = tac2tac_ pt p (Add_Find "valuesFor [(a::real)]"); 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*uncaught exception TYPE 6.5.03*)

if ppc<>(Problem [],  
         {Find=[Incompl "maximum",Incompl "valuesFor [a]"],
	  Given=[Correct "fixedValues [r = Arbfix]"],
	  Relate=[Incompl "relations []"], Where=[],With=[]})
then raise error "test-maximum.sml: model stepwise - different behaviour" 
else (); (*different with show_types !!!*)
6.5.03---*)

(*-----appl_add should not create Error', but accept as Sup,Syn
val nxt = tac2tac_ pt p (Add_Given "boundVariable a"); 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)
val nxt = tac2tac_ pt p (Add_Given "boundVariable a+"); 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)---*)

val m = Specify_Problem ["maximum_of","function"];
val nxt = tac2tac_ pt p m; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

if ppc<>(Problem ["maximum_of","function"],  
         {Find=[Incompl "maximum",Incompl "valuesFor"],
	  Given=[Correct "fixedValues [r = Arbfix]"],
	  Relate=[Incompl "relations []"], Where=[],With=[]})
then raise error "diffappl.sml: Specify_Problem different behaviour" 
else ();
(* WN.3.9.03 (#391) Model_Specify did init_pbl newly 
if ppc<>(Problem ["maximum_of","function"],
   {Find=[Missing "maximum m_",Missing "valuesFor vs_"],
    Given=[Correct "fixedValues [r = Arbfix]"],
    Relate=[Missing "relations rs_"],Where=[],With=[]})
then raise error "diffappl.sml: Specify_Problem different behaviour" 
else ();*)

val nxt = tac2tac_ pt p(Specify_Method ["DiffApp","max_by_calculus"]);
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(**)

if ppc<>(Method ["DiffApp","max_by_calculus"],
	 {Find=[Incompl "maximum",Incompl "valuesFor"],
	  Given=[Correct "fixedValues [r = Arbfix]",Missing "boundVariable v_",
		 Missing "interval itv_",Missing "errorBound err_"],
	  Relate=[Incompl "relations []"],Where=[],With=[]})
then raise error "diffappl.sml: Specify_Method different behaviour" 
else ();
(* WN.3.9.03 (#391) Model_Specify did init_pbl newly 
if ppc<>(Method ["DiffApp","max_by_calculus"],
   {Find=[Missing "maximum m_",Missing "valuesFor vs_"],
    Given=[Correct "fixedValues [r = Arbfix]",Missing "boundVariable v_",
           Missing "interval itv_",Missing "errorBound err_"],
    Relate=[Missing "relations rs_"],Where=[],With=[]})
then raise error "diffappl.sml: Specify_Method different behaviour" 
else ();*)






" #################################################### ";
"              test specify, fmz <> []                  ";
" #################################################### ";
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ["DiffApp","max_by_calculus"]);
val c = []:cid;
(*val nxt = Init_Proof' (fmz,(dI',pI',mI'));*)
val (p,_,f,(_,nxt),_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt e_pos' [] pt;
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "fixedValues [(r::real) = Arbfix]" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "maximum (A::bool)" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "valuesFor [(a::real)]" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "valuesFor [(b::real)]" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Relation "relations [A = a * b]" *)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*Add_Relation "relations\n [((a::real) // (#2::real)) ..."*)

(*---------------------------- FIXXXXME.meNEW !!! partial Add-Relation !!!
  nxt_specif <> specify ?!

if nxt<>(Add_Relation 
 "relations [(a / 2) ^^^ 2 + (b / 2) ^^^ 2 = r ^^^ 2]")
then raise error "test specify, fmz <> []: nxt <> Add_Relation (a/2)^2.." else (); (*different with show_types !!!*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
------------------------------ FIXXXXME.meNEW !!! ---*)

(*val nxt = Specify_Theory "DiffApp.thy" : tac*)

val itms = get_obj g_pbl pt (fst p);writeln(itms2str thy itms);

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Problem ["maximum_of","function"]*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Method ("DiffApp.thy","max_by_calculus")*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "boundVariable a" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "interval {x. #0 <= x & x <= #2 * r}" : *)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "errorBound (eps = #0)" : tac*)

val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Apply_Method ("DiffApp.thy","max_by_calculus") *)
if nxt<>(Apply_Method ["DiffApp","max_by_calculus"])
then raise error "test specify, fmz <> []: nxt <> Apply_Method max_by_calculus" else ();


" #################################################### ";
"              test specify, fmz = []                  ";
" #################################################### ";
val fmz = [];
val (dI',pI',mI') = empty_spec;
val c = []:cid;

val nxt = Init_Proof' (fmz,(dI',pI',mI'));(*!!!!!!!!*)
(*val (p,_,f,(_,nxt),_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))]; !!!*)
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt e_pos' [] 
  EmptyPtree;
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Theory "e_domID" : tac*)

val nxt = Specify_Theory "DiffApp.thy";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Problem ["e_pblID"] : tac*)

val nxt = Specify_Problem ["maximum_of","function"];
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "fixedValues" : tac*)

val nxt = Add_Given "fixedValues [r=Arbfix]";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "maximum" : tac*)

val nxt = Add_Find "maximum A";
val nxt = tac2tac_ pt p nxt; 


val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Find "valuesFor" : tac*)

val nxt = Add_Find "valuesFor [a]";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Relation "relations" --- 
  --- [b=Arbfix] KANN NICHT VERLANGT WERDEN !!!!*)

(*30.8.01 ... funktioniert nicht mehr nach Einfuehrung env ....
if nxt<>(Add_Relation "relations []")
then raise error "test specify, fmz <> []: nxt <> Add_Relation.." 
else (); (*different with show_types !!!*)
*)

val nxt = Add_Relation "relations [(A=a+b)]";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Specify_Method ("e_domID","e_metID") : tac*)

val nxt = Specify_Method ["DiffApp","max_by_calculus"];
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "boundVariable" : tac*)

val nxt = Add_Given "boundVariable alpha";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "interval" : tac*)

val nxt = Add_Given "interval {x. 2 <= x & x <= 3}";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Add_Given "errorBound" : tac*)

val nxt = Add_Given "errorBound (eps=999)";
val nxt = tac2tac_ pt p nxt; 
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt;
(*val nxt = Apply_Method ("DiffApp","max_by_calculus") *)
(*30.8.01 ... funktioniert nicht mehr nach Einfuehrung env ....
if nxt<>(Apply_Method ("DiffApp.thy","max_by_calculus"))
then raise error "test specify, fmz <> []: nxt <> Add_Relation.." 
else ();
*)

(* 2.4.00 nach Transfer specify -> hard_gen
val nxt = Apply_Method ("DiffApp.thy","max_by_calculus");
val(p,_,Form'(PpcKF(_,_,_,_,ppc)),nxt,_,pt) = specify nxt p [] pt; *)
(*val nxt = Empty_Tac : tac*)



(* use_thy_only"Isa99/knowl-base/Script";
   *)



" #################################################### ";
"          problemtypes + formalizations               ";
" #################################################### ";
" -------------- [maximum_of,function] --------------- ";
val pbt = 
    ["fixedValues fix_","maximum m_","valuesFor vs_","relations rs_"];
map (the o (parseold thy)) pbt;
val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
map (the o (parseold thy)) fmz;
" -------------- [make,function] -------------- ";
val pbt = 
    ["functionOf f_","boundVariable v_","equalities eqs_",
     "functionTerm f_0_"];
map (the o (parseold thy)) pbt;
val fmz12 =
    ["functionOf A","boundVariable a","boundVariable b",
     "equalities [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    ["functionOf A","boundVariable a","boundVariable b",
     "equalities [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [univar,equation] --------- ";
val pbt = 
    ["equality e_","solveFor v_","solutions v_i_"];
map (the o (parseold thy)) pbt;
val fmz =
    ["equality ((a/2)^^^2 + (b/2)^^^2 = r^^^2)",
     "solveFor b","solutions b_i"];
map (the o (parseold thy)) fmz;
" ---- [on_interval,maximum_of,function] ---- ";
val pbt = 
    ["functionTerm t_","boundVariable v_","interval itv_",
     "errorBound err_","maxArgument v_0_"];
map (the o (parseold thy)) pbt;
val fmz12 =
    [(*28.11.00: "functionTerm (A_0 = a*sqrt(#4*r^^^#2 - a^^^#2))",*)
     "functionTerm (a*sqrt(4*r^^^2 - a^^^2))",
     (*28.11.00: "functionTerm (A_0 = b*sqrt(#4*r^^^#2 - b^^^#2))",*)
     "functionTerm (b*sqrt(4*r^^^2 - b^^^2))",
     "boundVariable a","boundVariable b",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "errorBound (eps=0)","maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    [(*28.11.00: "functionTerm (A_0 = (#2*r*sin alpha)*(#2*r*cos alpha))",*)
     "functionTerm ((2*r*sin alpha)*(2*r*cos alpha))",
     "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=0)","maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [derivative_of,function] --------- ";
val pbt = 
    ["functionTerm f_","boundVariable v_","derivative f_'_"];
map (the o (parseold thy)) pbt;
val fmz =
    [(*28.11.00: "functionTerm (A_0=a*#2*sqrt r^^^#2 - (a//#2)^^^#2)",*)
     "functionTerm (a*2*sqrt r^^^2 - (a/2)^^^2)",
     "boundVariable a",
     (*28.11.00: "derivative (A_0'=Undef)"*)"derivative (Undef)"];
map (the o (parseold thy)) fmz;
" --------- [find_values,tool] --------- ";
val pbt = 
    ["maxArgument ma_","functionTerm f_","boundVariable v_",
     "valuesFor vls_","additionalRels rs_"];
map (the o (parseold thy)) pbt;
val fmz1 =
    ["maxArgument (a_0=(srqt 2)*r)",
     (*28.11.00: "functionTerm (A_0=a*#2*sqrt r^^^#2 - (a//#2)^^^#2)",*)
     "functionTerm (a*2*sqrt r^^^2 - (a/2)^^^2)",
     "boundVariable a",
     "valuesFor [a,b]","maximum A",
     "additionalRels [(a/2)^^^2 + (b/2)^^^2 = r^^^2]"];
map (the o (parseold thy)) fmz1;



"-------------------- ptree of {(a,b). is-max ... --------------------------";
"-------------------- ptree of {(a,b). is-max ... --------------------------";
"-------------------- ptree of {(a,b). is-max ... --------------------------";

(* Teil von max-on-surface.sml,
   der nach Init_Proof -> prep_ori wieder l"auft
   (f"ur tests mit neuer pos')
   use"test-max-surf1.sml";

   Compiler.Control.Print.printDepth:=7; (*4 is default*)
   Compiler.Control.Print.printDepth:=4; (*4 is default*)
   *)

(* --vvv-- ausgeliehen von test-root-equ/sml *)
val loc = e_istate;
val (dI',pI',mI') =
  ("Script.thy",["sqroot-test","univariate","equation"],
   ["Script","squ-equ-test2"]);
val fmz = ["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))",
	   "solveFor x","errorBound (eps=0)",
	   "solutions L"];
(*
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val ((p,p_),_,_,_,_,(_,pt,_)) = do_ (mI,m) e_pos'[1](e_scr,EmptyPtree,[]);
 --^^^-- ausgeliehen von test-root-equ/sml *)
(*-------------- 9.6.03 --- cappend_ ... term -------irreparabler test
val (pt,_) = 
  cappend_problem EmptyPtree [] loc ([],(dI',pI',mI'));
val pos = (lev_on o lev_dn) [];
(* val pos = ([1]) *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). is-max ..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([1,1])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-max ..." 
    Empty_Tac ("[1,1]:{(a,b). is-extremum ...",[]) Complete;
val pos = lev_on pos;
(*val pos = ([1,2])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-extremum ..." 
    Empty_Tac ("[1,2]:{(a,b). f_x(a,b) ...",[]) Complete;
val pos = lev_up pos;
(*val pos = ([1])*)
val (pt,_) = append_result pt pos e_istate ("[1#]:{(a,b). f_x(a,b) ...",[])
    Complete;

val pos = lev_on pos;
(*val pos = ([2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x(a,b) ..." 
    Empty_Tac ("[2]:{(a,b). f_x & f_xx &...",[]) Complete;
val pos = lev_on pos;
(*al pos = [3] : pos*)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x & f_xx &..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*pos = ([3,1]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx & ..." 
    Empty_Tac ("[3,1]:{(a,b). f_x & f_xx } cup ...",[]) Complete;
val pos = lev_on pos;
(*pos = ([3,2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx } cup.."
    Empty_Tac ("[3,2]:{(a,b). f_x ..} cup ...",[]) Complete;

val pos = lev_up pos;
(*pos = ([3]) *)
val (pt,_) = append_result pt pos e_istate ("[3#]:{(a,b). f_x ..} cup..",[])
    Complete;
val pos = lev_on pos;
(*val pos = [4] : pos *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x ..} cup ..." 
    Empty_Tac IntersectB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1]) *)
val (pt,_) = cappend_parent pt pos loc "set_1 = ..." 
    Empty_Tac SequenceB;


val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc"f_x = d/dx x^3 ..."
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1]) *)
val (pt,_) = cappend_parent pt pos loc "d/dx x^3 ..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1,1]) *)
val (pt,_) = cappend_atomic pt pos loc "d/dx x^3 ..." 
    Empty_Tac ("[4,1,1,1,1]:3x^2 + d/dx ...",[]) Complete;
val pos = lev_on pos;
(*val pos = ([4,1,1,1,2]) *)
val (pt,_) = cappend_atomic pt pos loc "3x^2 + d/dx ..." 
    Empty_Tac ("[4,1,1,1,2]:3x^2 + 0 + d/dx ...",[]) Complete;
val pos = lev_on pos;
(*pos = ([4,1,1,1,3]) *)
val (pt,_) = cappend_atomic pt pos loc "3x^2 + 0 + d/dx ..." 
    Empty_Tac ("[4,1,1,1,3]:3x^2 + 0 -3 ...",[]) Complete;
"--- 1 ---";
val pos = lev_up pos;
(*pos = ([4,1,1,1]) *)
val (pt,_) = append_result pt pos e_istate ("[4,1,1,1#]:3x^2 -3.",[])Complete;
"--- 2 ---";
val pos = lev_up pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = append_result pt pos e_istate ("[4,1,1#]:found 3x^2 -3 ...",[])
    Complete;
"--- 3 ---";
val pos = lev_on pos;
(*val pos = ([4,1,2]+) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc "f_y = d/dy x^3 ..."
    Empty_Tac TransitiveB;
"--- 4 ---";
writeln (pr_ptree pr_short pt);

(*
.    ----- pblobj -----
1.   {(a,b). is-max ...
1.1.   {(a,b). is-max ...
1.2.   {(a,b). is-extremum ...
2.   {(a,b). f_x(a,b) ...
3.   {(a,b). f_x & f_xx &...
3.1.   {(a,b). f_x & f_xx & ...
3.2.   {(a,b). f_x & f_xx } cup..
4.   {(a,b). f_x ..} cup ...
4.1.   set_1 = ...
4.1.1.   f_x = d/dx x^3 ...
4.1.1.1.   d/dx x^3 ...
4.1.1.1.1.   d/dx x^3 ...
4.1.1.1.2.   3x^2 + d/dx ...
4.1.1.1.3.   3x^2 + 0 + d/dx ...
4.1.2.   f_y = d/dy x^3 ...
  
 use"test-max-surf1.sml";
   *)
-------------- 9.6.03 --- cappend_ ... term -------irreparabler test---*)


"--------- me .. scripts for maximum-example ---------------------";
"--------- me .. scripts for maximum-example ---------------------";
"--------- me .. scripts for maximum-example ---------------------";

val fmz =
    ["fixedValues [r=Arbfix]","maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",

     "boundVariable a","boundVariable b","boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("DiffApp.thy",["maximum_of","function"],
   ["DiffApp","max_by_calculus"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn e;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Specify_Method",Specify_Method ["DiffApp","max_by_calculus"])*)

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);
val itms = get_obj g_pbl pt (fst p);writeln(itms2str thy itms);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt(*FIXXXXXXXXME: hide met-args !!!*);
val (p,_,f,nxt,_,pt) = me nxt p c pt(*Empty_Tac since before 040507!?!?!?*);
val (p,_,f,nxt,_,pt) = me nxt p c pt(*FIXXXXXXXXME: hide met-args !!!*);
(*val nxt = ("Apply_Method",Apply_Method ["DiffApp","max_by_calculus"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Subproblem",Subproblem ("DiffApp.thy",["make","function"]))*)
val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn_G e;

(*
Compiler.Control.Print.printDepth:=7; pt; (*@@@@@@@@@@###########*)
Compiler.Control.Print.printDepth:=4; pt; (*@@@@@@@@@@###########*)
print_depth 2;
*)

(*val nxt = ("Refine_Tacitly",Refine_Tacitly ["make","function"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Model_Problem",Model_Problem ["by_explicit","make","function"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);
val itms = get_obj g_pbl pt (fst p);writeln(itms2str thy itms);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Apply_Method",Apply_Method ["DiffApp","make_fun_by_explicit"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Subproblem ("DiffApp.thy",["univariate","equation"]))   *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Refine_Tacitly ["univariate","equation"])*)

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);
val itms = get_obj g_pbl pt (fst p);writeln(itms2str thy itms);

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Apply_Method",Apply_Method ["PolyEq","normalize_poly"])*)

val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val f = Form' (FormKF (~1,EdUndef,3,Nundef,"A = a * b"))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val f = Form' (FormKF (~1,EdUndef,4,Nundef,"[b = A / a]"))*)



(*val f =
Error' (Error_ "Refine_Tacitly [\"univariate\",\"equation\"] not applicable")*)


(*----GOON.15.5.03 run scripts for maximum-example: univariate equation ?!?

val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn e; 

val oris = fst3 (get_obj g_origin pt (fst p));writeln(oris2str oris);

val itms = get_obj g_pbl pt (fst p);writeln(itms2str thy itms);
val itms = get_obj g_pbl pt [];writeln(itms2str thy itms);

val itms = get_obj g_met pt (fst p);writeln(itms2str thy itms);
val itms = get_obj g_met pt [];writeln(itms2str thy itms);

itms2args thy ["DiffApp","max_by_calculus"] itms;

val (p,_,f,nxt,_,pt) = me nxt p c pt;

---*)

"--------- autoCalc .. scripts for maximum-example ---------------";
"--------- autoCalc .. scripts for maximum-example ---------------";
"--------- autoCalc .. scripts for maximum-example ---------------";
(*++++++++ see systest/auto-inform.sml 'complete_metitms' ++++++++*)
 states:=[];
 CalcTree [(fmz, (dI',pI',mI'))];
 Iterator 1; moveActiveRoot 1;
 autoCalculate 1 CompleteCalcHead;
 refFormula 1 (get_pos 1 1); 

 fetchProposedTactic 1;
 autoCalculate 1 (Step 1);

 fetchProposedTactic 1;
 autoCalculate 1 (Step 1);
 (*Subproblem on_interval maximum_of function*)
 autoCalculate 1 CompleteCalcHead;

 fetchProposedTactic 1;
 val ((pt,p),_) = get_calc 1;
 val mits = get_obj g_met pt (fst p);
 writeln (itms2str thy mits);
 if itms2str thy mits = "[\n(1 ,[1] ,true ,#Given ,Cor functionEq (hd rs_) ,(t_, [hd rs_])),\n(2 ,[1] ,true ,#Given ,Cor boundVariable v_ ,(v_, [v_])),\n(3 ,[1] ,true ,#Given ,Cor interval itv_ ,(itv_, [itv_])),\n(4 ,[1] ,true ,#Find ,Cor maxArgument v__0 ,(v_0_, [v__0]))]" then ()
 else raise error "diffapp.sml: diff.behav. in autoCalc .. scripts for max 1";
 (*FIXME: the environments contain identifers, and NOT values ?!?!?*)


